#include "font.h"
#include "lcd1202.h"
#include <EEPROM.h>

//*******************************************************************************************************************************************************
//***** Автор шрифтов и функциый дисплея jeka_tm http://arduino.ru/forum/proekty/khronograf-izmeritel-skorosti-puli-ot-prostogo-k-slozhnomu?page=5#comment-136147
//***** Все собрал в библиотеку Gres, взять библиотеку для Arduino можно тут: https://yadi.sk/d/uwlwBOyijDYYR
//********************************************************************************************************************************************************
//***** Автор дозиметра Евгений Галкин (OfficialGalkin) http://offgal.ru/
//***** Вход в инженерное меню - В режиме поиска Left Key + Righ Key
//********************************************************************************************************************************************************


LCD1202 lcd(9, 8, 7, 6);  // RST, CS, MOSI, SCK (hx1230 (RST, CE, DIN, CLK)) -- можно менять местами
int bl = 5; //подсветка пин
int ledPin = 3; //пин светодиода индикации частиц
int buzPin = 4; //пин бузера индикации частиц
int batr = 2; //пин батареи А2
int charj = 4; //пин зарядки А4

int LK = 13; //Пин левой - кнопки
int RK = 10; //Пин правой + кнопки
int OK = 11; //Пин ОК кнопки
int MK = 12; //Пин кнопки вверх

// ------------------------------------------------------------------------------------------------------------------------------------------------------

unsigned long mspik; //Для работы задержки индикации частиц
byte aaa = 0; //и это тоже

byte ABC = 0; //Флаг означающий что включение первое и задает настройки ниже, а не из EEPROM
byte ABCD = 0; //Флаг означающий что включение первое и задает нулевые значения дозы, а не из EEPROM

int POWER = 1; //Кнопка POWER A1
boolean PK = 0; //Значение кнопки POWER 1 or 0
byte POWERSCHET = 0; // Время нажатия на кнопку POWER

boolean LKK = 0;
boolean RKK = 0;
boolean OKK = 0;
boolean MKK = 0;
boolean RK1 = 0;
boolean LK1 = 0;
boolean OK1 = 0;
boolean lookey = 0;
byte zar = 0;

byte injk = 0; //Для курсора в инженерном меню

float cef = 100; //кэф батарейки. (при делителе 1 к 10 - 100)
byte datch = 40;  //время замера сек для СТС-5 36 (СБМ-20 40)
byte datch_k = 100; //кэф датчика в процентах.
byte maxBAT = 41;
byte minBAT = 30;

byte menuvib = 0; //Для курсора и надписей в меню выбора режимов

//Сигнализация превышения порогов
byte porog1 = 30; //Порог 1 реагирует на средний фон (кратное 10, 10-100)
unsigned int porog2 = 100; //Порог 2 реагирует на фон быстрого замера (Кратное 100, 100-100000)
unsigned long porog_ms = 0; //Для работы единовременного сигнала о превышении Порог 1
boolean TR = 0; //Флаг тревоги2
boolean TRS = 0; //Флаг тревоги2 для сброса
byte  TR1 = 0; //Флаг тревоги1

byte buzType = 1; //Тип бузера (тестово!!!)

byte offtsT = 0; //Для счета минут до отключения

//ячейки для счета усредненного фона
unsigned long sredn1 = 0;
unsigned long sredn2 = 0;
unsigned long sredn3 = 0;
unsigned long sredn4 = 0;
unsigned long sredn5 = 0;
unsigned long sredn6 = 0;

unsigned long shet = 0; //частицы
unsigned long sredn, shet_sr; //для подсчета среднего фона
float fon_sr = 0; //вывод среднего фона
unsigned long temp = 0; //для вывода среднего фона большими цыфрами
unsigned long temp2 = 0; //для вывода  фона большими цыфрами
unsigned long temp3 = 0; //для вывода  фона огромными цыфрами
byte menu = 0; //отображаемый экран на старте
byte pol = 0; //полоска 1
byte pol2 = 0; //полоска 2
byte sekzam = 0; //для замеров в поиске
volatile byte timer_seconds;
boolean mig;
byte sek = 0;
unsigned int raspad = 0;
int  raspadost = 0;
byte poiski = 0; //график, счет и тд
byte poiski2 = 0; //смена цыферок

//График
int graf[47];
int shet_g;

unsigned long maxp = 0;

float HV = 0.0;
float BAT = 0.0;
float BAT1 = 0.0;
byte BAT_STEP = 0;
byte batline = 0;

//для работы быстрого замера
unsigned long shet1 = 0;
float shet2 = 0;
float shet3 = 0;
unsigned long fon = 0; //вывод фона
float fon1 = 0;
float fon2 = 0;
unsigned long sekzam2 = 0; //для быстрых замеров в поиске
byte takt = 0;

//для работы шкалы поиска
float lineP = 0;
float linePl = 0;
byte linePy = 1;
byte linePx = 0;
unsigned long linePmillis = 0;

boolean pixi = 0; //для смещения цыфр в пределах 1-100 Мр/ч

//обновление экрана
unsigned long ekran = 0;




//подсчет времени дозы
unsigned long tdoze = 0;
unsigned long tdozet = 0;

//подсчет дозы
unsigned long doza_all = 0;
float doza_all_s = 0;
float doza_s = 0;
float doza_t = 0;
byte doza_sev = 1000; //Сохранять каждые 1000Мкр

//настройки
byte sett = 0; //выбиранный пункт меню
boolean izmen = 0; //были ли изменения

boolean alarm_s = 1; //Сигнализация ВКЛ/ВЫКЛ
boolean podsvet = 1; //Подсветка ВКЛ/ВЫКЛ
byte podsvet_u = 100; //Подсветка уровень
byte podsvet_l = 100; //Подсветка уровень
boolean zvuk = 1; //Звук каждой частицы ВКЛ/ВЫКЛ
boolean svet = 1; //Свет каждой частицы ВКЛ/ВЫКЛ
byte zamer_min = 1; //Время разностного замера
unsigned int ton = 1000;
byte offts = 10;  //Время авто выключения в минутах
boolean LOUBATTOFF = 1;  //Автоотключение по пониженному напряжению

boolean savev = 0; //меню сохранения ДА НЕТ

//разностной замер

int zamer_sek = 0;
byte zamer_takt = 0;
unsigned long schet_zamer = 0;
unsigned long schet_zamer1 = 0;
unsigned long schet_zamer2 = 0;
float schet_itog = 0;
byte minz = 0;
byte sekz = 0;
byte mm = 0;
byte ss = 0;

boolean ASD = 0;

void setup() {
// настраиваем таймер на секундный интервал
  TCCR1A=(1<<WGM11); //режим14 FAST PWM 
  TCCR1B=(1<<CS12)|(1<<WGM13)|(1<<WGM12); //делить частоту CPU на 256
if (F_CPU == 16000000UL) 
 {
  ICR1=62499;  // (16000000MHz /div256) -1 = 1 раз в секунду
 }
else if (F_CPU == 8000000UL) 
 {
  ICR1=31249;  // (8000000MHz /div256) -1 = 1 раз в секунду
 } 
  TIMSK1=(1<<TOIE1); //разрешить прерывание
//-----------------------------------------------------------
analogReference(INTERNAL);
pinMode(LK, INPUT);
pinMode(RK, INPUT);
pinMode(OK, INPUT);
pinMode(MK, INPUT);
pinMode(ledPin, OUTPUT);
pinMode(bl, OUTPUT);
pinMode(4, OUTPUT); 
pinMode(14, OUTPUT);
pinMode(17, OUTPUT); 
EEPROM.get(0, ABC);
EEPROM.get(48, ABCD);
if (ABC == 11) {doza_all_s = doza_all; eeprom_read();} else {save1();}// Проверяем, первое ли включение
if (ABCD == 11) {EEPROM.get(60, tdoze);EEPROM.get(50, doza_all);doza_all_s = doza_all;}

if (digitalRead(OK) == 1) {ASD = 1;}
start(); //стартуем
}

void loop() {
  
if (batline>1) {
lcd.drawBitmap(83, 0, tf, 13, 6, 1); //фоновая картинка батарейки
lcd.fillRect(95-batline, 1, 10, 4, 1);
}
if (batline<=1 && mig) {  //если 10% заряда или менее, то мигаем батарейкой
lcd.drawBitmap(83, 0, tf, 13, 6, 1); //фоновая картинка батарейки
lcd.fillRect(95-batline, 1, 10, 4, 1);
}


if (lookey == 1 && mig) {lcd.drawBitmap(0, 0, lk, 30, 6, 1);} //картинка блокировки
if (offts != 0) {lcd.drawBitmap(56, 0, av, 5, 6, 1);} if (offts - offtsT <= 2 && mig) {lcd.drawBitmap(49, 0, av, 5, 6, 0);} //картинка автоотключения
if (alarm_s == 1) {lcd.drawBitmap(63, 0, al, 5, 6, 1);} //картинка сирены
if (svet == 1) {lcd.drawBitmap(70, 0, lgh, 4, 6, 1);} //картинка света
if (zvuk == 1) {lcd.drawBitmap(76, 0, so, 5, 6, 1);} //картинка звука
//if (zar > 50 && mig) {lcd.drawBitmap(76, 0, chrj, 5, 6, 1);} //картинка зарядки


//------------------------------------ считаем -----------------------------------------------------------------------
if (millis() - sekzam2 >= 1000) { //Быстрый замер. Эффективен на высоких интенсивностях излучения
  sekzam2 = millis();
  shet1 = shet1*datch;
  if (takt < datch) {shet2 = shet2 + shet1;}
  if (takt < datch) {takt++;}
  if (takt == datch) {shet2 = (shet2 - (shet2/datch)) + shet1;}
  fon2 = (shet2/takt)/100.00*datch_k;

  shet3 = (shet3 -shet3/4) + shet1; //Считаем fon1 усреднением за 4 секунды
  fon1 = (shet3/400.00)*datch_k; // делим на 400 так как 4 замера

  if (fon1 > fon2 && fon1 > 300) {fon = fon1;   raspad = (shet1/datch)*600;} else {fon = fon2; raspad = ((shet2/takt)/datch)*600;}
  if (fon2 > fon1*5 && fon2 > datch*5) {shet2=shet2/2;}
  raspadost = raspad % 10;
  shet1 = 0;
  maxp = max(maxp, fon);
}


if (sekzam >= datch) { //Долгий замер. Для более точного фона на низких энергиях
  if (sredn < 6) {sredn++;}
  sekzam = 0;
  sredn1 = sredn2;
  sredn2 = sredn3;
  sredn3 = sredn4;
  sredn4 = sredn5;
  sredn5 = sredn6;
  sredn6 = shet;
  shet_sr = sredn1 + sredn2 + sredn3 + sredn4 + sredn5 + sredn6;
  fon_sr = (shet_sr/sredn)/100.00*datch_k;
  shet = 0;
}
//------------------------------------------------------
//------------------------ Вызов функиций раз в секунду-
if (sek){
  grafik();
  BAT_read();
  POWERSCHET++;
  sek=0; //не трогать
  if (mig == 0) {mig = 1;} else {mig = 0;} //мигания
  if (offts > 0) {if (offtsT >= offts){poweroff();}} //Автоотключение

        }
//--------------------------- БЛОКИРОВКА КЛАВИШ -------------------------
if (lookey == 0) { //если клавиши не заблокированы
LKK = digitalRead(LK);
RKK = digitalRead(RK);
OKK = digitalRead(OK);
MKK = digitalRead(MK);
RK1 = digitalRead(RK);
LK1 = digitalRead(LK);
OK1 = digitalRead(OK);
PK = map(analogRead(POWER), 0, 1023, 1, 0);
if (OK1 == 1 && RK1 == 1) {Obk(); lookey = 1; analogWrite(14,255);} //блокируем нажатием ПРАВОЙ + кнопки и ОК
if (OK1 == 1 && LK1 == 1) {Obk(); lookey = 1; analogWrite(14,255);} //блокируем нажатием ЛЕВОЙ + кнопки и ОК
if (OKK || LKK || MKK || RKK) {offtsT = 0;} //Сбрасываем счет автоотключения если нажата была клавиша
//---------------------------- ОБРАБОТКА ОТКЛЮЧЕНИЯ ----------------------
if (millis() >= 5000) //Ждем 5 секунд после включения
{
if (PK == 1) {
  if (POWERSCHET >=2){lcd.drawRect(1, 1, 5, 5, 1);}
  if (POWERSCHET >=3){lcd.drawRect(2, 2, 3, 3, 1);}
  if (POWERSCHET >=4){lcd.drawRect(3, 3, 1, 1, 1);}
  if (POWERSCHET >=5){poweroff();}
              }
else
               {
POWERSCHET = 0;
               }
}
//------------------------------------------------------------------------

} else { //если клавиши заблокированы
RK1 = digitalRead(RK);
LK1 = digitalRead(LK);
OK1 = digitalRead(OK);
if (OK1 == 1 && RK1 == 1) {Obk(); lookey = 0;} //разблокируем нажатием ПРАВОЙ + кнопки и ОК
if (OK1 == 1 && LK1 == 1) {Obk(); lookey = 0;} //разблокируем нажатием ЛЕВОЙ + кнопки и ОК
}
//----------------------------------------------------
    if (menu == 0)   //режим поиска
      {
        rpoisk();  //вывод на дисплей режима поиск
        if (OKK == 1 && TR == 1) {Obk(); TRS = 1;}
        if (PK == 1) {Obk(); menu = 4; }
        if (LKK == 1 && RKK == 1) {Obk(); menu = 111; }
        if (OKK == 0 && MKK == 1) {Obk(); Sbros();}
        if (LKK == 0 && RKK == 1) {Obk(); if (poiski == 2) {poiski = 0;} else {poiski++;}}
        if (LKK == 1 && RKK == 0) {Obk(); if (poiski2 == 1) {poiski2 = 0;} else {poiski2++;}}
      }
    if (menu == 1)   //режим разностного замера
      {
        razno();  //вывод
        if (OKK == 0 && PK == 1 && LKK == 0 && RKK == 0) {if (POWERSCHET >=1){Obk(); menu = 4;  zamer_takt = 0; Sbros();}} //Выходим из меню разностного замера, удержанием PK
        if (zamer_takt == 0){
         if (OKK == 1) {Obk(); zamer_takt = 1; zamer_sek = 0; schet_zamer = 0; minz = zamer_min; sekz = 0;mm = 0;ss = 0;}
        }
        if (zamer_takt == 2){
         if (OKK == 1) {Obk(); zamer_takt = 3; zamer_sek = 0; schet_zamer = 0; minz = zamer_min; sekz = 0;mm = 0;ss = 0;}
        }
      }
    if (menu == 2)   //режим 
      {
        doza();  //вывод
        if (OKK == 0 && PK == 1 && LKK == 0 && RKK == 0) {Obk(); menu = 4; }
      }
    if (menu == 3)   //настройки
      {
        setting();  //вывод на дисплей режима настройки
        if (PK == 1) {Obk(); if (izmen == 1) {menu = 5;} else {menu = 4;} sett = 0;izmen = 0;}
        if (OKK == 1 && MKK == 0) {Obk(); if (sett == 14) {sett = 0;} else {sett++;} }
        if (OKK == 0 && MKK == 1) {Obk(); if (sett == 0) {sett = 14;} else {sett--;} }
        if (izmen == 0 && sett != 11 && sett != 10) {if (LKK == 1 || RKK == 1) {delay (10);izmen = 1;}} //Делались ли изменения?
        sett = constrain (sett, 0, 14);
          if (sett == 0) {
              if (LKK == 1 && RKK == 0) {Obk(); alarm_s = 0;}
              if (LKK == 0 && RKK == 1) {Obk(); alarm_s = 1;}
              }
          if (sett == 1) {
              if (LKK == 1 && RKK == 0) {Obk(); podsvet = 0; analogWrite(bl, 0);}
              if (LKK == 0 && RKK == 1) {Obk(); podsvet = 1; analogWrite(bl, podsvet_u);}
              }
          if (sett == 2) {
              if (LKK == 1 && RKK == 0) {Obk();  if (podsvet_u > 51){podsvet_u -= 50; analogWrite(bl, podsvet_u);}}
              if (LKK == 0 && RKK == 1) {Obk();  if (podsvet_u < 201){podsvet_u += 50; analogWrite(bl, podsvet_u);}}
              podsvet_u = constrain (podsvet_u, 50, 250);
              }
          if (sett == 3) {
              if (LKK == 1 && RKK == 0) {Obk(); svet = 0;}
              if (LKK == 0 && RKK == 1) {Obk(); svet = 1;}
              }
          if (sett == 4) {
              if (LKK == 1 && RKK == 0) {Obk(); zvuk = 0;}
              if (LKK == 0 && RKK == 1) {Obk(); zvuk = 1;}
              }
          if (sett == 5) {
              if (LKK == 1 && RKK == 0) {Obk(); ton -= 50;}
              if (LKK == 0 && RKK == 1) {Obk(); ton += 50;}
              ton = constrain (ton, 100, 2000);
              }
          if (sett == 6) {
              if (LKK == 1 && RKK == 0) {Obk(); if (offts > 0){offts -= 5;}}
              if (LKK == 0 && RKK == 1) {Obk(); if (offts < 60){offts += 5;}}
              offts = constrain (offts, 0, 60);
              }
          if (sett == 7) {
              if (LKK == 1 && RKK == 0) {Obk(); LOUBATTOFF = 0;}
              if (LKK == 0 && RKK == 1) {Obk(); LOUBATTOFF = 1;}
              }
         if (sett == 10) {
              if (LKK == 1 || RKK == 1) {Obk(); eeprom_clear();}
              }
         if (sett == 11) {
              if (LKK == 1 || RKK == 1) {Obk(); doza_clear();}
              }
           if (sett == 12) {
              if (LKK == 1 && RKK == 0) {Obk();  if (zamer_min > 1){zamer_min--;}}
              if (LKK == 0 && RKK == 1) {Obk();  if (zamer_min < 60){zamer_min++;}}
              }
           if (sett == 13) {
              if (LKK == 1 && RKK == 0) {Obk();  if (porog1 > 10){porog1-=10;}}
              if (LKK == 0 && RKK == 1) {Obk();  if (porog1 < 100){porog1+=10;}}
              }
           if (sett == 14) {
              if (LKK == 1 && RKK == 0) {Obk();  if (porog2 > 10000){porog2 -= 1000;} else if (porog2 > 1000){porog2 -= 500;} else {porog2 -= 100;}}
              if (LKK == 0 && RKK == 1) {Obk();  if (porog2 < 1000){porog2 += 100;} else if (porog2 < 10000){porog2 += 500;} else {porog2 += 1000;}}
              porog2 = constrain (porog2, 100, 60000);
              }
      }
    if (menu == 4)  //меню выбора режимов
      {
        menuv();  //вывод на дисплей меню выбора.
        if (OKK == 1 && MKK == 0) {Obk(); menu = menuvib; if(menuvib==1){Sbros();} menuvib = 0;} //нажатие ок
        if (LKK == 1 && RKK == 0) {Obk();  if (menuvib == 0) {menuvib = 3;} else {menuvib--;}}
        if (RKK == 1 && LKK == 0) {Obk();  if (menuvib == 3) {menuvib = 0;} else {menuvib++;}}
        menuvib = constrain (menuvib, 0, 3);
      }
    if (menu == 5)  //меню сохранения
      {
        save();  //вывод на дисплей меню сохранения.
        if (OKK == 1 && MKK == 0) {Obk(); if (savev == 0){eeprom_wr();}else{eeprom_read();menu = 4;} savev = 0;} //нажатие ок
        if (LKK == 1 && RKK == 0) {Obk();  savev = 0;}
        if (RKK == 1 && LKK == 0) {Obk();  savev = 1;}
      }
    if (menu == 111) 
      {
        menuinj();  //вывод на дисплей инженер. меню
        if (LKK == 1 && RKK == 1) {Obk(); menu = 0; }
        if (OKK == 0 && MKK == 1) {Obk();  if (injk > 6 || injk == 0){injk = 6;} else {injk--;}}
        if (OKK == 1 && MKK == 0) {Obk();  if (injk >= 6){injk = 0;} else {injk++;}}
           if (injk == 0) {
        if (LKK == 1 && RKK == 0) {Obk();  if (datch > 1){datch--;}}
        if (LKK == 0 && RKK == 1) {Obk();  if (datch < 100){datch++;}}
                          }
           if (injk == 1) {
        if (LKK == 1 && RKK == 0) {Obk();  if (datch_k > 50){datch_k--;}}
        if (LKK == 0 && RKK == 1) {Obk();  if (datch_k < 150){datch_k++;}}
                          }
           if (injk == 2) {
        if (LKK == 1 && RKK == 0) {Obk();  if (cef > 1){cef--;}}
        if (LKK == 0 && RKK == 1) {Obk();  if (cef < 200){cef++;}}
                          }
           if (injk == 3) {
        if (LKK == 1 && RKK == 0) {Obk();  if (minBAT > 10){minBAT--;}}
        if (LKK == 0 && RKK == 1) {Obk();  if (minBAT < 60 && minBAT < maxBAT){minBAT++;}}
                          }
           if (injk == 4) {
        if (LKK == 1 && RKK == 0) {Obk();  if (maxBAT > 30 && minBAT < maxBAT){maxBAT--;}}
        if (LKK == 0 && RKK == 1) {Obk();  if (maxBAT < 99){maxBAT++;}}
                          }
           if (injk == 5) {
        if (LKK == 1 && RKK == 0) {Obk(); eeprom_wrinj();}
        if (LKK == 0 && RKK == 1) {Obk(); eeprom_wrinj();}
                          }
           if (injk == 6) {
        if (LKK == 1 && RKK == 0) {Obk(); menu = 0;}
        if (LKK == 0 && RKK == 1) {Obk(); menu = 0;}
                          }
      }

//щелчки и свет
if (aaa == 1 && millis() - mspik >= 10){aaa = 2;digitalWrite(ledPin, LOW);if (buzType == 0){digitalWrite(buzPin, LOW);}else {noTone(buzPin);}}
if (aaa == 2 && millis() - mspik >= 50){aaa = 0;}
//тревога 2-го уровеня
if (fon >= porog2 && TR == 0 && alarm_s) {TR = 1;}
if (fon < porog2 && TR == 1) {digitalWrite(buzPin, LOW);noTone(buzPin);TR = 0; TRS = 0;}
if (TR && mig && !TRS){if (buzType == 0){digitalWrite(buzPin, HIGH);}else {tone (buzPin,1000,500);}}
if (TR && !mig && !TRS){if (buzType == 0){digitalWrite(buzPin, LOW);}else {noTone(buzPin);tone (buzPin,700,500);}}
//тревога 1-го уровня
if (fon_sr >= porog1 && TR1 == 0 && alarm_s) {porog_ms = millis();TR1 = 1;}
if (fon_sr >= porog1 && TR1 == 1 && millis() - porog_ms <= 1000) {if (buzType == 0){digitalWrite(buzPin, HIGH);}else {tone (buzPin,700,500); if (millis() - porog_ms >= 500){tone (buzPin,1000,500);}}}
if (fon_sr >= porog1 && TR1 == 1 && millis() - porog_ms > 1000) {if (buzType == 0){digitalWrite(buzPin, LOW);}else {noTone(buzPin);};;TR1 = 2;}
if (fon_sr < porog1 && TR1 == 2) {TR1 = 0;}
} // end loop
//----------------------------------------------------------------------------------------
void Obk() {delay (200);LKK = 0; RKK = 0; OKK = 0; MKK = 0;} //для корректной работы клавиш
//----------------------------------------------------------------------------------------
void menuinj() {
lcd.drawBitmap(6, 6, injn, 41, 62, 1); //фоновая картинка
lcd.print(55, 7, 1, datch);lcd.print(79, 6, 1, "Сек");
lcd.print(55, 15, 1, datch_k);lcd.print(79, 15, 1, "%");
lcd.print(55, 24, 1, cef); 
lcd.print(79, 37, 1, BAT); lcd.drawPixel(84, 43, 1);
lcd.print(55, 33, 1, minBAT*10); lcd.drawPixel(60, 39, 1);
lcd.print(55, 42, 1, maxBAT*10); lcd.drawPixel(60, 48, 1);
lcd.drawBitmap(0, 6+(injk*9), kyrsor, 4, 7, 1);
obnov();
  }
  
//------------------------------------------------------ Режим посика --------------------------

void rpoisk() { 
if (poiski2 == 0){ //--------------------------------------------------------------------------------------- 1-й экран
  lcd.fillRect(0, 7, 96, 20, 1);
  lcd.drawRect(0, 26, 41, 19, 1);
  lcd.drawFastVLine(2, 28, 7, 1);
  lcd.drawFastVLine(38, 28, 7, 1);
  lcd.drawFastHLine(2, 31, 37, 0);

  if (TR1){lcd.fillRect(75, 9, 19, 8, 0); lcd.print(76, 10, 1, "МКР" );} else {lcd.print(76, 10, 0, "МКР" );} // Белый фон при тревоге1
  lcd.print(76, 17, 0, "час" );
  
  temp = fon_sr; // переменная для хранения среднего фона
  unsigned int c6=temp%10;                        // 6
  temp/=10;
  unsigned int c5=temp%10;                        // 5
  temp/=10;
  unsigned int c4=temp%10;                        // 4
  temp/=10;
  unsigned int c3=temp%10;                        // 3
  temp/=10;
  unsigned int c2=temp%10;                        // 2
  temp/=10;
  unsigned int c1=temp%10;                        // 1
  lcd.simb10x16(2,  9, 0, c1);
  lcd.simb10x16(14, 9, 0, c2);
  lcd.simb10x16(26, 9, 0, c3);
  lcd.simb10x16(38, 9, 0, c4);
  lcd.simb10x16(50, 9, 0, c5);
  lcd.simb10x16(62, 9, 0, c6);

  if (fon >= 1000 && fon < 100000) {pixi = 1; lcd.fillRect(64, 43, 2, 2, 1);} else  {pixi = 0;} //смещение цифр для точки
  if (fon >= 1000000) {temp2 = fon/1000000;  lcd.print(86, 30, 1, "Р" );}
  else if  (fon >= 100000) {temp2 = fon/1000;  lcd.print(82, 30, 1, "мр" );}
  else if  (fon >= 1000) {temp2 = fon/100; lcd.print(82, 30, 1, "мр" );}
  else {temp2 = fon;  lcd.print(79, 30, 1, "мкр" );}// переменная для хранения
  
  unsigned int b3=temp2%10;                        // 3
  temp2/=10;
  unsigned int b2=temp2%10;                        // 2
  temp2/=10;
  unsigned int b1=temp2%10;                        // 1
  lcd.simb10x16(43 - pixi, 29, 1, b1);
  lcd.simb10x16(54 - pixi, 29, 1, b2);
  lcd.simb10x16(65 + (pixi*2), 29, 1, b3);
  lcd.print(79, 36, 1, "час" );

if (TR && mig){lcd.fillRect(79, 29, 17, 16, 0);lcd.drawBitmap(79, 29, beg, 17, 16, 1);} // Иконка бега при тревоге2
lcd.print(2, 36, 1, raspad/10); if (raspad < 999999){lcd.print(34, 36, 1, raspadost); lcd.drawPixel(32, 42, 1);}

//---------- полоски -----
pol2 = ((sredn*100)/6)*0.35;
pol = ((sekzam*100)/datch)*0.35; //полоска 1
lcd.fillRect(3, 28, pol, 3, 1);
lcd.fillRect(3, 32, pol2, 3, 1);
//---------------

}else{ //------------------------------------------------------------------------------------------------------ 2-й экран
  if (TR && mig){lcd.drawBitmap(68, 17, beg, 17, 16, 1);} // Иконка бега при тревоге2
  if (fon1 >= 1000 && fon1 < 100000) {pixi = 1;  lcd.fillRect(38, 40, 3, 3, 1);} else  {pixi = 0;} //смещение цифр для точки
  if (fon1 >= 10000) {temp3 = fon1/1000;lcd.print(65, 35, 1, "МР/ч" );}
   else if (fon1 >= 1000) {temp3 = fon1/100;lcd.print(65, 35, 1, "МР/ч" );}
   else {temp3 = fon1;lcd.print(65, 35, 1, "МКР/ч" );}// переменная для хранения 
  unsigned int b3=temp3%10;                        // 3
 temp3/=10;
  unsigned int b2=temp3%10;                        // 2
 temp3/=10;
  unsigned int b1=temp3%10;                        // 1
  
lcd.simb16x32(4 - pixi, 10, 1, b1);
lcd.simb16x32(22 - pixi, 10, 1, b2);
lcd.simb16x32(40 + (pixi*2), 10, 1, b3);
}//----------------------------------------------------------------------------------------------------------------------

if (poiski == 2) {
  lcd.fillRect(0, 47, linePl/2, 10, 1);  lcd.fillRect(0, 57, lineP, 10, 1); if (lineP > 96) {linePy = lineP/96;} else {linePy = 1;}
  if (millis() - linePmillis >= (1000/linePy)) {linePx = linePy; linePl = linePl/2+lineP; lineP = 0; linePmillis = millis();} lcd.print(80, 52, 1, "Х");lcd.print(86, 52, 1, linePx);
}
if (poiski == 1) {
lcd.fillRect(0, 47, 96, 21, 1);
lcd.print(2, 49, 0, "MAX:" );   lcd.print(26, 49, 0, maxp );    lcd.print(66, 49, 0, fon1 ); lcd.print(66, 57, 0, fon2 ); 
}
if (poiski == 0) {
  lcd.fillRect(94, 68-shet_g, 2, 68, 1);
  for (int i = 0; i < 47; i ++)  //печатаем график
    {
      if (graf[i]>=21){
            lcd.fillRect(i*2, 68-21, 2, 68, 1);
      }else
      {lcd.fillRect(i*2, 68-graf[i], 2, 68, 1);}
    }
}
obnov();
}
//---------------------------------------------------------------------------------------------
void grafik(){
for (int i = 0; i < 47; i++) {graf[i] = graf[i + 1];}
if (shet_g>=21){graf[46] = 21;}else{graf[46] = byte(shet_g);}
shet_g = 0;
}
//---------------------------------------------------------------------------------------------
void razno(){
if (zamer_takt == 0) {schet_zamer1 = 0;schet_zamer2 = 0;}
if (zamer_takt == 0 || zamer_takt == 2) {
lcd.drawBitmap(0, 7, zam1, 96, 61, 1); //фоновая картинка
if (zamer_min >= 10) {lcd.print(42, 38, 1, zamer_min);} else {lcd.print(45, 38, 1, zamer_min);}
if (zamer_takt == 2){lcd.print(84, 20, 1, "2");}
// склонение чеслительных
if (zamer_min%10==1 && zamer_min%100!=11) {lcd.print(86, 38, 1, "а");} else if (zamer_min%10>=2 && zamer_min%10<=4 && (zamer_min%100<10 || zamer_min%100>=20)) {lcd.print(86, 38, 1, "ы");}
}
if (zamer_takt == 1) {
  schet_zamer1 = schet_zamer;
  if (zamer_min*60-zamer_sek <= 0) {
    if (buzType == 0){digitalWrite(buzPin, HIGH);}
    else {tone (buzPin,1000,1000);}
    delay(1000);
    digitalWrite(buzPin, LOW);
    zamer_takt = 2;}
}
if (zamer_takt == 3) {
  schet_zamer2 = schet_zamer;
  if (zamer_min*60-zamer_sek <= 0) {
    if (schet_zamer1 > schet_zamer2) {schet_itog = schet_zamer1 - schet_zamer2;}
    if (schet_zamer2 > schet_zamer1) {schet_itog = schet_zamer2 - schet_zamer1;}
    if (zvuk == 1) {
      if (buzType == 0){digitalWrite(buzPin, HIGH);}
      else {tone (buzPin,1000,1000);}
      delay(1000);
      digitalWrite(buzPin, LOW);
                   }
    zamer_takt = 4;
                                   }
                     }

if (zamer_takt > 0 && zamer_takt != 2) {
lcd.drawBitmap(0, 7, frz_head, 96, 13, 1); 
lcd.drawRect(0, 7, 96, 61, 1);
lcd.drawLine(0, 31, 96, 31, 1);
lcd.drawLine(48, 20, 48, 31, 1);
}


if (zamer_takt == 1 || zamer_takt == 3) {
lcd.fillRect(0, 51, 96, 20, 1);

if (zamer_takt == 1 && mig){lcd.print(12, 10, 0, "<<<");}
if (zamer_takt == 3 && mig){lcd.print(67, 10, 0, ">>>");}
lcd.print(3, 22, 1, schet_zamer1);
lcd.print(51, 22, 1, schet_zamer2);
if (sekz > 60){sekz = 59;minz--;} 

  lcd.fillRect(93, 48-shet_g, 2, 68, 1);
  for (int i = 0; i < 47; i ++)  //печатаем график
  {if (graf[i]>=16){lcd.fillRect(i*2-1, 48-16, 2, 47, 1);}else{lcd.fillRect(i*2-1, 48-graf[i], 2, 47, 1);}}
    
if (mig){lcd.drawBitmap(47, 53, tt, 2, 9, 0);}
mm = minz;                         // переменная для хранения
  unsigned int mm2=mm%10;                        // 2
  mm/=10;
  unsigned int mm1=mm%10;                        // 1
  lcd.simb10x16(23,  50, 0, mm1);
  lcd.simb10x16(35, 50, 0, mm2);
ss = sekz;                         // переменная для хранения
  unsigned int ss2=ss%10;                        // 2
  ss/=10;
  unsigned int ss1=ss%10;                        // 1
  lcd.simb10x16(51,  50, 0, ss1);
  lcd.simb10x16(63, 50, 0, ss2);

}

if (zamer_takt == 4) {
lcd.drawBitmap(0, 31, frz_itog, 96, 37, 1); 
lcd.print(3, 22, 1, schet_zamer1);
lcd.print(51, 22, 1, schet_zamer2);
lcd.print(3, 46, 1, ((schet_itog)/(zamer_min*60)*datch)/100.00*datch_k);
lcd.print(71, 46, 1, zamer_min);
}

obnov();
}
//---------------------------------------------------------------------------------------------
//---------------------------------------------------------------------------------------------
void doza(){
 lcd.drawBitmap(2, 21, dozaback, 92, 15, 1); //фоновая картинка
 lcd.drawBitmap(2, 51, dozaback, 92, 15, 1); //фоновая картинка
 lcd.drawRect(0, 7, 96, 61, 1);
 lcd.fillRect(0, 7, 96, 11, 1);lcd.fillRect(0, 37, 96, 11, 1);
 lcd.print(3, 9, 0, "Накопленная"); lcd.print(3, 39, 0, "Текущая");

 
 lcd.print(34, 19, 1, doza_all_s); 
 lcd.print(2, 19, 1, tdoze/1440);
 unsigned int tdh=tdoze%1440; 
 lcd.print(34, 29, 1, tdh/60);
 unsigned int tdm=tdh%60; 
 lcd.print(83, 29, 1, tdm);
 lcd.print(2, 49, 1, tdozet/1440);
 unsigned int tdhh=tdozet%1440; 
 lcd.print(34, 59, 1, tdhh/60);
 unsigned int tdmm=tdhh%60; 
 lcd.print(83, 59, 1, tdmm);
 lcd.print(34, 49, 1, doza_t);
obnov();
}
//---------------------------------------------------------------------------------------------
void dozaplus(){
tdoze++;tdozet++;
doza_t += fon_sr/60; //мкр.ч делим на 60 минут
if (doza_t - doza_s >= 1) { doza_all_s += doza_t - doza_s; doza_s = doza_t;}
if (doza_all_s - doza_all >= doza_sev) { doza_all = doza_all_s; EEPROM.put(50, doza_all);EEPROM.put(60, tdoze); ABCD = 11; EEPROM.put(48, ABCD);_delay_ms(20);}
}
//---------------------------------------------------------------------------------------------
void setting(){ //Меню настроек
if (sett <=5) {// вкладка 1
lcd.drawBitmap(0, 7, nastr1, 96, 61, 1); 
lcd.drawBitmap(0, 19+(sett*8), kyrsor, 4, 7, 0);
if (alarm_s == 1) {lcd.drawBitmap(70, 19, on, 18, 7, 1);} else {lcd.drawBitmap(70, 19, off, 24, 7, 1);}
if (podsvet == 1) {lcd.drawBitmap(70, 27, on, 18, 7, 1);} else {lcd.drawBitmap(70, 27, off, 24, 7, 1);}
lcd.print(70, 35, 1, podsvet_u/2.5);
if (svet == 1) {lcd.drawBitmap(70, 43, on, 18, 7, 1);} else {lcd.drawBitmap(70, 43, off, 24, 7, 1);}
if (zvuk == 1) {lcd.drawBitmap(70, 51, on, 18, 7, 1);} else {lcd.drawBitmap(70, 51, off, 24, 7, 1);}
lcd.print(70, 59, 1, ton);

} else if (sett > 5 && sett <=11){ // вкладка 2
lcd.drawBitmap(0, 7, nastr2, 96, 61, 1); 
lcd.drawBitmap(0, 19+((sett-6)*8), kyrsor, 4, 7, 0);

if (offts == 0) {lcd.fillRect(70, 19, 24, 7, 0);lcd.drawBitmap(70, 19, off, 24, 7, 1);} else {lcd.print(54, 19, 1, offts);}
if (LOUBATTOFF == 1) {lcd.drawBitmap(70, 27, on, 18, 7, 1);} else {lcd.drawBitmap(70, 27, off, 24, 7, 1);}

}
else {// вкладка 3
lcd.drawBitmap(0, 7, nastr3, 96, 61, 1); 
lcd.drawBitmap(0, 27+((sett-12)*16), kyrsor, 4, 7, 0);
lcd.print(7, 27, 1, zamer_min);
lcd.print(7, 43, 1, porog1);
lcd.print(7, 59, 1, porog2);
}

obnov();
}
//---------------------------------------------------------------------------------------------
void menuv() { //Меню выбора
lcd.drawBitmap(0, 7, mv, 96, 27, 1); //фоновая картинка
lcd.drawRect(3+(23*menuvib), 10, 21, 21, 1);
if (menuvib == 0) {lcd.drawBitmap(0, 34, m1, 96, 34, 1);}
if (menuvib == 1) {lcd.drawBitmap(0, 34, m2, 96, 34, 1);}
if (menuvib == 2) {lcd.drawBitmap(0, 34, m3, 96, 34, 1);}
if (menuvib == 3){lcd.drawBitmap(0, 34, m4, 96, 34, 1);}
obnov();
}
//---------------------------------------------------------------------------------------------
void Sbros() { //Сброс замеров
  maxp = 0;

  sredn = 0;
  shet_sr =0;
  sredn1 = 0;
  sredn2 = 0;
  sredn3 = 0;
  sredn4 = 0;
  sredn5 = 0;
  sredn6 = 0;
  
  sekzam = 0;
  takt = 0;
  shet = 0;
  shet1 = 0;
  shet2 = 0;
  shet3 = 0;
  sekzam2 = millis();
  
  fon = 0;
    fon1 = 0;
      fon2 = 0;
  fon_sr = 0;
  raspad = 0;

  TR = 0;
  TR1 = 0;

  }
//---------------------------------------------------------------------------------------------
void save(){
  lcd.drawBitmap(3, 44, si, 90, 21, 1); //фоновая картинка
  lcd.fillRect(0, 7, 96, 35, 1);
  lcd.fillRect(3, 14, 90, 22, 0);
  lcd.print(20, 20, 1, "Сохранить?");
  lcd.drawRect(3+(46*savev), 44, 44, 21, 1);
  obnov();
}
//---------------------------------------------------------------------------------------------
void Schet() { //регистрация частицы пин 2
  detachInterrupt(0);
  shet1++; 
  if (shet_g < 21 && menu != 1) {shet_g++;}
  if (shet_g < 17 && menu == 1) {shet_g++;}
  if (menu == 1) {schet_zamer++;} //Счет для разностного замера
  if (menu != 1) {shet++;} //Не считаем средний фон, если в реиме разностного замера 
  attachInterrupt(0, Schet, FALLING);
  if (aaa == 0 && millis() > 3000 && !TR && TR1 != 1) {Pik();} //Если нет тревог, включаем индикацию частичек.
  if (lineP < 960 && menu == 0 && poiski == 2) {lineP++;}
}
//---------------------------------------------------------------------------------------------
void Pik() { //Индикация каждой частички
mspik = millis();
aaa = 1;
if (svet == 1){digitalWrite(ledPin, HIGH);}
if (zvuk == 1){if (buzType == 0){digitalWrite(buzPin, HIGH);} else {tone (buzPin,ton,5);}}
}
//---------------------------------------------------------------------------------------------
void start() { //Старт
analogWrite(14,1023); //Поддерживаем высокий уровень А0 для открытия N канального мосфета, включение.
lcd.Inicialize();  //Инициализация дисплея
lcd.Clear_LCD();  //Очистка дисплея
if (podsvet == 1){analogWrite(bl, podsvet_u);} //подсветка

lcd.drawBitmap(38, 1, sl1, 13, 40, 1); //выводим фоновую картинку
lcd.drawBitmap(0, 41, sl2, 96, 27, 1); //выводим фоновую картинку
lcd.Update();_delay_ms(500);
BAT = (analogRead(batr)*0.0118)*cef;_delay_ms(50); //Проверяем батарейку


lcd.print(6, 36, 1, "1.0"); //выводим версию прошивки
lcd.Update();_delay_ms(1000);

lcd.Clear_LCD();
Sbros();
BAT_read();
attachInterrupt(0, Schet, FALLING);
}
//---------------------------------------------------------------------------------------------
void obnov() { // обновление экрана
  if (millis() - ekran >= 100) {ekran = millis();lcd.Update();lcd.Clear_LCD();}  //Обновляем и очищаем дисплей
  }
//---------------------------------------------------------------------------------------------
void BAT_read() {
BAT1 = (analogRead(batr)*0.0118)*cef;
if (BAT1 >= BAT) {BAT = BAT1;} else {
  if (BAT - BAT1 <= 5) {BAT = BAT1;}
  if (BAT - BAT1 > 5) {BAT_STEP += 1;} else {BAT_STEP = 0;} if (BAT_STEP > 5) {BAT = BAT1;} // Защита от больших скачков.
  // Если напряжение отличается более чем на 0.05В от последнего в течении 5 секунд, то уменьшаем значение.
                                    }
//уровень заряда батареи в верхнем баре
if (BAT<=minBAT*10) {batline = 0;}
else if (BAT<=maxBAT*10)
{batline = ((BAT - minBAT*10) * 10) / (maxBAT*10 - minBAT*10);}
else {batline = 10;}

if (LOUBATTOFF == 1 && BAT<=minBAT*10 && ASD == 0) { //если включено отключение по пониженному напряжению то при достижении минимального порога вызываем функцию отключения
    lcd.fillRect(0, 7, 96, 61, 1);
  lcd.fillRect(3, 20, 90, 30, 0);
  lcd.print(28, 25, 1, "Батарея");
  lcd.print(22, 35, 1, "Разряжена");
  lcd.Update();_delay_ms(5000);
  poweroff();}
//zar = analogRead(charj)/10;
}
//---------------------------------------------------------------------------------------------
void poweroff() {
    digitalWrite(ledPin, LOW);
    digitalWrite(buzPin, LOW);
    zvuk = 0;
    svet = 0;
    menu = 69;lcd.fillRect(0, 7, 96, 61, 0); lcd.Update();_delay_ms(500); // Переходим в несуществующее меню 
    lcd.print(10, 30, 1, "Все сбросили");Sbros();lcd.Update();_delay_ms(500); 
    doza_all = doza_all_s; ABCD = 11; EEPROM.put(48, ABCD); EEPROM.put(50, doza_all);EEPROM.put(60, tdoze);lcd.print(5, 40, 1, "Дозу сохранили");lcd.Update();_delay_ms(500); // Сохраняем дозу
    lcd.print(15, 50, 1, "До встречи");lcd.Update();_delay_ms(1000);
    lcd.fillScreen(0);lcd.Update();_delay_ms(100);
    analogWrite(14,0); //отрубаем питание
    _delay_ms(60000); // Выключаем
    
    }
//---------------------------------------------------------------------------------------------
ISR (TIMER1_OVF_vect) // прерывание по таймеру, генерируемое каждую секунду
{ 
sekzam++; //долгий замер
//sekzam2++; //быстрый замер
if (menu == 1) {zamer_sek++; if (zamer_takt == 1 || zamer_takt == 3) {sekz--;}}
sek++; //секунда
timer_seconds++ ; //инкремент переменной каждую секунду
if (timer_seconds > 59){
                        timer_seconds = 0;
                        dozaplus();
                        if (menu != 1 && offts > 0){offtsT += 1;} //Добавляем минуту к таймеру счета отключения. Если в режиме разностного замера то не считаем
                       }
}
//---------------------------------------------------------------------------------------------
void eeprom_read()  //чтение настроек из памяти 
{
  EEPROM.get(1, podsvet);
  EEPROM.get(2, zvuk); 
  EEPROM.get(3, alarm_s);  
  EEPROM.get(4, svet); 
  EEPROM.get(5, podsvet_u);
  EEPROM.get(6, zamer_min);
  EEPROM.get(7, porog1);
  EEPROM.get(8, porog2);
  EEPROM.get(10, ton);
  EEPROM.get(13, datch);
  EEPROM.get(14, datch_k);
  EEPROM.get(18, cef);
  EEPROM.get(22, offts);
  EEPROM.get(23, minBAT);
  EEPROM.get(24, maxBAT);
  EEPROM.get(25, LOUBATTOFF);
}
//---------------------------------------------------------------------------------------------
void eeprom_clear()  //сброс настроек
{ 
  ABC = 255;
  EEPROM.put(0, 255);
  lcd.Clear_LCD();  
  lcd.fillRect(0, 0, 96, 68, 1);
  lcd.fillRect(3, 20, 90, 30, 0);
  lcd.print(28, 26, 1, "Очищено");
  lcd.print(9, 34, 1, "Перезагрузите");
  obnov();
  _delay_ms(5000);menu = 20;
}
//---------------------------------------------------------------------------------------------
void doza_clear()  //сброс дозы
{ 
  ABCD = 255;
  EEPROM.put(48, 255);
  EEPROM.put(50, 0);
  EEPROM.put(60, 0);
  tdoze = 0;
  tdozet = 0;
  doza_all = 0;
  doza_all_s = 0;
  doza_s = 0;
  doza_t = 0;
  lcd.Clear_LCD();  
  lcd.fillRect(0, 0, 96, 68, 1);
  lcd.fillRect(3, 20, 90, 30, 0);
  lcd.print(6, 31, 1, "Доза сброшена!");
  obnov();
  _delay_ms(2000);
}
//---------------------------------------------------------------------------------------------
void eeprom_wr()  //запись настроек
{ 
  ABC = 11;
  EEPROM.put(0, ABC);
  EEPROM.put(1, podsvet);
  EEPROM.put(2, zvuk);   
  EEPROM.put(3, alarm_s);  
  EEPROM.put(4, svet);
  EEPROM.put(5, podsvet_u);
  EEPROM.put(6, zamer_min);
  EEPROM.put(7, porog1);
  EEPROM.put(8, porog2);
  EEPROM.put(10, ton);
  EEPROM.put(22, offts);
  EEPROM.put(25, LOUBATTOFF);
  lcd.Clear_LCD();  
  lcd.fillRect(0, 0, 96, 68, 1);
  lcd.fillRect(3, 20, 90, 30, 0);
  lcd.print(6, 31, 1, "ВСЕ СОХРАНЕНО!");
  obnov();
  delay(2000);
  menu = 4;
}
//---------------------------------------------------------------------------------------------
void eeprom_wrinj()  //запись инженерных настроек
{ 
  ABC = 11;
  EEPROM.put(0, ABC);
  EEPROM.put(13, datch);
  EEPROM.put(14, datch_k);
  EEPROM.put(18, cef);
  EEPROM.put(23, minBAT);
  EEPROM.put(24, maxBAT);
  lcd.Clear_LCD();  
  lcd.fillRect(0, 0, 96, 68, 1);
  lcd.fillRect(3, 20, 90, 30, 0);
  lcd.print(6, 31, 1, "ВСЕ СОХРАНЕНО!");
  obnov();
  delay(2000);
  menu = 111;
}
//---------------------------------------------------------------------------------------------
void save1()  //запись настроек при первом включении
{ 
  ABC = 11;
  EEPROM.put(0, ABC);
  EEPROM.put(1, podsvet);
  EEPROM.put(2, zvuk);   
  EEPROM.put(3, alarm_s);  
  EEPROM.put(4, svet);
  EEPROM.put(5, podsvet_u);
  EEPROM.put(6, zamer_min);
  EEPROM.put(7, porog1);
  EEPROM.put(8, porog2);
  EEPROM.put(10, ton);
  EEPROM.put(0, ABC);
  EEPROM.put(13, datch);
  EEPROM.put(14, datch_k);
  EEPROM.put(18, cef);
  EEPROM.put(22, offts);
  EEPROM.put(23, minBAT);
  EEPROM.put(24, maxBAT);
  EEPROM.put(25, LOUBATTOFF);
  delay(1000);
}
